VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Stable Appointments"
   ClientHeight    =   6270
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6330
   LinkTopic       =   "Form1"
   ScaleHeight     =   6270
   ScaleWidth      =   6330
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtAssignments 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2775
      Left            =   2880
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   3
      Top             =   240
      Width           =   1575
   End
   Begin VB.CommandButton cmdGo 
      Caption         =   "Go"
      Default         =   -1  'True
      Height          =   495
      Left            =   1800
      TabIndex        =   2
      Top             =   1200
      Width           =   855
   End
   Begin VB.TextBox txtPreferences 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2775
      Left            =   0
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   1
      Top             =   240
      Width           =   1575
   End
   Begin VB.Label lblAssignments 
      Alignment       =   2  'Center
      Caption         =   "Assignments"
      Height          =   255
      Left            =   2880
      TabIndex        =   4
      Top             =   0
      Width           =   1575
   End
   Begin VB.Label lblPreferences 
      Alignment       =   2  'Center
      Caption         =   "Preferences"
      Height          =   255
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   1575
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
' Display the assignments.
Private Function AssignmentSummary(assigned_to() As Person, people() As Person) As String
Dim txt As String
Dim i As Integer
Dim total As Integer

    txt = "Assignments" & vbCrLf
    For i = LBound(assigned_to) To UBound(assigned_to)
        If assigned_to(i) Is Nothing Then
            txt = txt & i & ": Nothing" & vbCrLf
            total = total + DONT_WANT
        Else
            txt = txt & i & ": " & assigned_to(i).AssignmentString() & vbCrLf
            total = total + assigned_to(i).Value()
        End If
    Next i
    txt = txt & "----------" & vbCrLf

    txt = txt & "People" & vbCrLf
    total = 0
    For i = LBound(people) To UBound(people)
        txt = txt & people(i).AssignmentString() & vbCrLf
        total = total + people(i).Value()
    Next i
    txt = txt & "Total Value: " & total & vbCrLf

    AssignmentSummary = txt
End Function
Private Sub cmdGo_Click()
Dim txt As String
Dim num_people As Integer
Dim lines() As String
Dim i As Integer
Dim people() As Person
Dim obj As Variant
Dim per As Person
Dim obj2 As Variant
Dim per2 As Person
Dim assigned_to(0 To NUM_CHOICES - 1) As Person
Dim pref As Integer
Dim desired_choice As Integer
Dim had_improvement As Boolean
Dim per_assignment As Integer
Dim per2_assignment As Integer
Dim old_cost As Integer
Dim new_cost As Integer

    ' Get the Persons' preferences.
    txt = txtPreferences.Text
    Do While Right$(txt, Len(vbCrLf)) = vbCrLf
        txt = Left$(txt, Len(txt) - Len(vbCrLf))
    Loop
    lines = Split(txt, vbCrLf)
    num_people = UBound(lines) - LBound(lines) + 1
    ReDim people(0 To num_people - 1)
    For i = 0 To num_people - 1
        Set people(i) = New Person
        people(i).InitializeValues (lines(i))
    Next i

    ' Clear assignments.
    For i = 0 To NUM_CHOICES - 1
        Set assigned_to(i) = Nothing
    Next i

    ' Make initial choice assignments.
    For pref = 0 To NUM_PREFERENCES - 1
        ' Try to assign this choice for Persons.
        For Each obj In people
            Set per = obj
            ' See if this Person has an assignment yet.
            If per.Assignment < 0 Then
                ' This Person is unassigned.
                ' See if this choice is available.
                desired_choice = per.Preferences(pref + 1)
                If assigned_to(desired_choice) Is Nothing Then
                    ' Assign this Person.
                    Set assigned_to(desired_choice) = per
                    per.Assignment = desired_choice
                End If
            End If
        Next obj
    Next pref

    'Debug.Print "Preferred assignments"
    'Debug.Print AssignmentSummary(assigned_to, people)
    'Debug.Print "********************"
    'Stop

    ' Assign anyone without an assignment.
    For Each obj In people
        Set per = obj
        ' See if this Person has an assignment yet.
        If per.Assignment < 0 Then
            ' This Person is unassigned.
            ' Find an available choice.
            For i = 0 To NUM_CHOICES - 1
                If assigned_to(i) Is Nothing Then
                    ' Assign this Person.
                    Set assigned_to(i) = per
                    per.Assignment = i
                    Exit For
                End If
            Next i
        End If
    Next obj

    'Debug.Print "Initial assignments"
    'Debug.Print AssignmentSummary(assigned_to, people)
    'Debug.Print "********************"
    'Stop

    ' Try to improve the assignments.
    Do
        had_improvement = False

        ' Look for profitable swaps.
        For Each obj In people
            Set per = obj

            For Each obj2 In people
                Set per2 = obj2
                per2_assignment = per2.Assignment
                per_assignment = per.Assignment

                ' See if per and per2 should swap.
                old_cost = per.Value + per2.Value
                new_cost = _
                    per.ValueOf(per2_assignment) + _
                    per2.ValueOf(per_assignment)
                If new_cost < old_cost Then
                    ' Make the swap.
                    per.Assignment = per2_assignment
                    per2.Assignment = per_assignment
                    Set assigned_to(per_assignment) = per2
                    Set assigned_to(per2_assignment) = per
                    had_improvement = True
                End If
            Next obj2
        Next obj
    
        'Debug.Print "Improved assignments"
        'Debug.Print AssignmentSummary(assigned_to, people)
        'Debug.Print "********************"
        'Stop
    Loop While had_improvement

    ' Display the results.
    txtAssignments.Text = AssignmentSummary(assigned_to, people)
End Sub
' Make some random preferences.
Private Sub Form_Load()
Dim pref As Integer
Dim i As Integer
Dim j As Integer
Dim txt As String

    Randomize
    For i = 1 To DEFAULT_NUM_PEOPLE
        txt = txt & Chr$(Asc("A") + i - 1) & " "

        For j = 1 To NUM_PREFERENCES
            pref = (pref + _
                Int(Rnd * (NUM_CHOICES - j)) + 1) Mod NUM_CHOICES
            txt = txt & pref & " "
        Next j
        txt = txt & vbCrLf
    Next i

    txtPreferences.Text = txt
End Sub


Private Sub Form_Resize()
Dim hgt As Single
Dim wid As Single

    hgt = Me.ScaleHeight - txtPreferences.Top
    If hgt < 120 Then hgt = 120
    txtPreferences.Height = hgt
    txtAssignments.Height = hgt

    cmdGo.Left = (Me.ScaleWidth - cmdGo.Width) / 2
    cmdGo.Top = (Me.ScaleHeight - cmdGo.Height) / 2

    wid = (Me.ScaleWidth - 2 * 120 - cmdGo.Width) / 2
    If wid < 120 Then wid = 120
    txtPreferences.Width = wid
    txtAssignments.Width = wid
    txtAssignments.Left = cmdGo.Left + cmdGo.Width + 120

    lblPreferences.Width = txtPreferences.Width
    lblAssignments.Width = lblAssignments.Width
    lblAssignments.Left = txtAssignments.Left
End Sub
